import { AfterContentInit, QueryList, ElementRef, SimpleChanges, OnChanges } from "@angular/core";
import { ActionRegistry } from "../../model/actionregistry";
import { Validator } from "../../model/validator";
import { TemplateSchemaService } from "../template-schema.service";
import { ButtonComponent } from "../button/button.component";
import { FieldParent } from "./field-parent";
import { FieldType, Field, TNullableFieldType } from "./field";
import { ItemComponent } from "./item/item.component";
import { ISchema } from "../../model/ISchema";
import * as i0 from "@angular/core";
export declare class FieldComponent extends FieldParent implements Field, OnChanges, AfterContentInit {
    private elementRef;
    private templateSchemaService;
    protected actionRegistry: ActionRegistry;
    childFields: QueryList<FieldComponent>;
    childItems: QueryList<ItemComponent>;
    childButtons: QueryList<ButtonComponent>;
    name: string;
    type: FieldType | TNullableFieldType;
    format: string;
    required: boolean;
    readOnly: boolean;
    title: string;
    description: string;
    placeholder: string;
    widget: string | object;
    validator: Validator;
    schema: ISchema;
    constructor(elementRef: ElementRef, templateSchemaService: TemplateSchemaService, actionRegistry: ActionRegistry);
    getSchema(): ISchema;
    getValidators(): {
        path: string;
        validator: Validator;
    }[];
    ngOnChanges(changes: SimpleChanges): void;
    private getOneOf;
    private setTitleFromContent;
    ngAfterContentInit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<FieldComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<FieldComponent, "sf-field", never, { "name": { "alias": "name"; "required": false; }; "type": { "alias": "type"; "required": false; }; "format": { "alias": "format"; "required": false; }; "required": { "alias": "required"; "required": false; }; "readOnly": { "alias": "readOnly"; "required": false; }; "title": { "alias": "title"; "required": false; }; "description": { "alias": "description"; "required": false; }; "placeholder": { "alias": "placeholder"; "required": false; }; "widget": { "alias": "widget"; "required": false; }; "validator": { "alias": "validator"; "required": false; }; "schema": { "alias": "schema"; "required": false; }; }, {}, ["childFields", "childItems", "childButtons"], ["*"], false, never>;
}
